--- freebsd/include/linux/videodev2.h.orig	2012-12-05 10:23:08.000000000 +0100
+++ freebsd/include/linux/videodev2.h	2012-12-05 10:25:46.864570965 +0100
@@ -56,10 +56,44 @@
 #ifndef __LINUX_VIDEODEV2_H
 #define __LINUX_VIDEODEV2_H
 
+#include <stdint.h>
 #include <sys/time.h>
+#include <sys/types.h>
+#include <sys/ioctl.h>
 
+#ifndef HAVE_LINUX_INTEGER_TYPES
+/* XXX remove when depending software has been updated */
+#ifndef __u64
+typedef uint64_t __u64;
+#endif
+#ifndef __u32
+typedef uint32_t __u32;
+#endif
+#ifndef __u16
+typedef uint16_t __u16;
+#endif
+#ifndef __u8
+typedef uint8_t __u8;
+#endif
+
+#ifndef __s64
+typedef int64_t __s64;
+#endif
+#ifndef __s32
+typedef int32_t __s32;
+#endif
+#ifndef __s16
+typedef int16_t __s16;
+#endif
+#ifndef __s8
+typedef int8_t __s8;
+#endif
+#endif
+
+#ifdef __KERNEL__
 #include <linux/ioctl.h>
 #include <linux/types.h>
+#endif
 #include <linux/v4l2-common.h>
 #include <linux/v4l2-controls.h>
 
